% Figure 1-4. Example of Digital Modulation 

clear all ;% clear all variables
close all
%============== Define global variables ===================================================
global BitRate Bits2Power Bits ChannelNumber ChannelSpacing TimeWindow SampleRate DataLength samplesperbit t_range f_sym Ref_Frequency

BitRate = 1e9;  
Bits2Power = 4;
Bits = 2^Bits2Power;
TimeWindow = Bits/BitRate;
ChannelNumber = 1;
ChannelSpacing = 100e9;   %[Hz]

SampleRateMargin = 3;  %MarginBandwidth = SampleRateMargin*ChannelSpacing
SampleRate = BitRate*SampleRateFactor(SampleRateMargin); %[Hz]

DataLength = TimeWindow*SampleRate;
Ref_Frequency = 193.41e12; %[Hz] Reference optical frequency, usually center frequency of simulations

samplesperbit = SampleRate/BitRate; % data number per bit

% time, optical frequency scale
t_range = 0:1/SampleRate:1/SampleRate*(DataLength-1);
f_sym = -.5/TimeWindow*(DataLength):1/TimeWindow:.5/TimeWindow*(DataLength-1);

%==========================================================================================

%=================== Define Simulation Blocks =============================================

%------------- Data Source -------------------%
PreSpaces = 1;  %number of leading zero bits
PostSpaces = 1; %number of trailing zero bits
info_bits = infobits_PRBS(PreSpaces,PostSpaces);
S_data = NRZCoder(info_bits);

RiseTime = 1/4/BitRate; %  In the form of k/BitRate, k should be less than (1/2)*RZRatio   

S_elec = RiseTimeAdjust(S_data,RiseTime);
figure(1)
plot(t_range,S_elec)

carrier1 = cos(2*pi*1e9*t_range);
carrier2 = cos(2*pi*1e10*t_range);

figure(2)
plot(t_range,S_elec,t_range,S_elec.*carrier1,'r')
%plot(t_range,S_elec.*carrier1)

figure(3)
plot(t_range,S_elec,t_range,S_elec.*carrier2,'r')

