% Fig8-21
clear all ;% clear all variables
close all

%============== Define global variables ===================================================
global  SampleRate DataLength  Ref_Frequency Bits samplesperbit t_range

BitRate = 1e9;  
Bits2Power = 6;
Bits = 2^Bits2Power;
TimeWindow = Bits/BitRate;
SampleRate = BitRate*2^10;
DataLength = TimeWindow*SampleRate;
Ref_Frequency = 193.1e12; %[Hz] Reference optical frequency
samplesperbit = SampleRate/BitRate; % data number per bit

% time, optical frequency range
t_range = 0:1/SampleRate:1/SampleRate*(DataLength-1);
f_sym = SampleRate*(-DataLength/2:(DataLength/2-1))/DataLength; %
%==========================================================================================
%=================== Define Simulation Blocks =============================================
% SM Laser
UnmodulatedPower = 1e-3; %[W] 
Linewidth = 10e6; %[Hz]
Laser1 = LaserCW(UnmodulatedPower,Linewidth);

%------------- Data Source -------------------%
PreSpaces = 2;  %number of leading zero bits
PostSpaces = 2; %number of trailing zero bits
info_bits = infobits_PRBS(PreSpaces,PostSpaces);

E_data = NRZCoder(info_bits);

ERiseTime = 1/4/BitRate; %  In the form of k/BitRate, k should be less than (1/2)*RZRatio if RZCoder used   
E_elec = RiseTimeAdjust(E_data,ERiseTime);

%------------- Modulation -------------------%
% Ideal amplitude modulation 

ModulationIndex = 1; 
mod_out = ModulatorAmplitude(Laser1,E_elec, ModulationIndex);

%---------------------------------------------
Loss = 20;%[dB]
mod_out_att = Attenuator(mod_out,Loss);

G_Target = Loss;
NFdB = 5; %[dB]


EDFA_out1 = EDFA_gain(mod_out_att,G_Target,'No',NFdB);
%EDFA_out2 = EDFA_gain(mod_out_att,G_Target,'Yes',NFdB);
EDFA_out2 = EDFA(mod_out_att,'Gain');

figure(1)
subplot 311
plot(t_range,abs(mod_out_att).^2)
subplot 312
plot(t_range,abs(EDFA_out1).^2)
subplot 313
plot(t_range,abs(EDFA_out2).^2)
axis([0 7e-8 0 2e-3])


